#include <stdexcept>
#include <iostream>
#include <vector>
using namespace std;



/** Infrastructure minimale de test **/
#define CHECK(test) if (!(test)) cerr << "Test failed in file " << __FILE__ << " line " << __LINE__ << ": " #test << endl
///BEGIN initialisationTD
vector<vector<int>> t={{7, -1, 4, 3}, {15, 11, 17, 12}, {20, 34, 42, 25}};
///END initialisationTD
vector<vector<int>> tabVide (0);
vector<vector<int>> tabCarre         = { { 1,  2, 3 },
                                         { 4, 11, 6 },
                                         { 9, 12, 7 } };
vector<vector<int>> tabRectangulaire = { { 1,  2, 3 },
                                         { 9, 12, 7 } };
vector<vector<int>> tabBizarre       = { { 1,  2, 3 },
                                         { 4,  5 },
                                         { 6,  7, 8, 10 } };

/// BEGIN initialisation



/// BEGIN nombreDeLignes

/** renvoie le nombre de lignes d'un tableau 2D d'entiers
 * @param t le tableau 2D d'entiers
 * @return le nombre de lignes du tableau t
 **/
int nombreDeLignes(vector<vector<int>> t) {
    // Remplacez cette ligne et la suivante par le code adéquat
    throw runtime_error("Fonction nombreDeLignes non implantée ligne 35");
}
/// END nombreDeLignes

void nombreDeLignesTest() {
    CHECK( nombreDeLignes(tabCarre) == 3 );
    CHECK( nombreDeLignes(tabRectangulaire) == 2 );
    CHECK( nombreDeLignes(tabBizarre) == 3 );
    CHECK( nombreDeLignes(tabVide) == 0 );
}

/// BEGIN nombreDeColonnes

/** renvoie le nombre de colonnes d'un tableau 2D d'entiers
 *  Par convention on considérera qu'un tableau vide a 0 colonnes.
 * @param t le tableau 2D d'entiers
 * @return le nombre de colonnes du tableau t
 **/
int nombreDeColonnes(vector<vector<int>> t) {
    // Remplacez cette ligne et la suivante par le code adéquat
    throw runtime_error("Fonction nombreDeColonnes non implantée ligne 55");
}
/// END nombreDeColonnes

void nombreDeColonnesTest() {
    CHECK( nombreDeColonnes(tabCarre) == 3 );
    CHECK( nombreDeColonnes(tabRectangulaire) == 3 );
    cout << "Lancement tests de nombreDeLignes pour un tableau vide" << endl;
    CHECK( nombreDeColonnes(tabVide) == 0 );
}

/// BEGIN afficheLigne

/** affiche tous les elements de la ligne l de t.
 * @param t le tableau 2D d'entiers
 * @param l un entier
 **/
void afficheLigne(vector<vector<int>> t, int l) {
    // Remplacez cette ligne et la suivante par le code adéquat
    throw runtime_error("Fonction afficheLigne non implantée ligne 74");
}
/// END afficheLigne

/// BEGIN afficheColonne

/** affiche tous les elements de la colonne c de t.
 * @param t le tableau 2D d'entiers
 * @param c un entier
 **/
void afficheColonne(vector<vector<int>> t, int c) {
    // Remplacez cette ligne et la suivante par le code adéquat
    throw runtime_error("Fonction afficheColonne non implantée ligne 86");
}
/// END afficheColonne

/// BEGIN afficheDiagonale

/** affiche tous les éléments de la première diagonale d'un
    tableau t supposé carré
 * @param t le tableau 2D d'entiers
 **/
void afficheDiagonale(vector<vector<int>> t) {
    // Remplacez cette ligne et la suivante par le code adéquat
    throw runtime_error("Fonction afficheDiagonale non implantée ligne 98");
}
/// END afficheDiagonale

/// BEGIN affiche

/** affiche tous les elements de t.
 * @param t le tableau 2D d'entiers
 **/
void affiche(vector<vector<int>> t) {
    // Remplacez cette ligne et la suivante par le code adéquat
    throw runtime_error("Fonction affiche non implantée ligne 109");
}
/// END affiche

/// BEGIN appartient

/** Test d'appartenance
 * @param t un tableau d'entiers à deux dimensions
 * @param x un entier
 * @return un booleen: true si x apparaît dans t, false sinon
 **/
bool appartient(vector<vector<int>> t, int x) {
    // Remplacez cette ligne et la suivante par le code adéquat
    throw runtime_error("Fonction appartient non implantée ligne 122");
}
/// END appartient

/** ajouter 4 tests verifiant le bon fonctionnement de la fonction appartient
**/
void appartientTest() {
    CHECK( not appartient(tabVide, 3) );

    // Remplacez cette ligne et la suivante par le code adéquat
    throw runtime_error("code non implanté ligne 132");

}

int main() {
    cout << "Lancement tests de nombreDeLignes" << endl;
    nombreDeLignesTest();
    cout << "Lancement tests de nombreDeColonnes" << endl;
    nombreDeColonnesTest();
    cout << "Appel de afficheLigne:" << endl;
    afficheLigne(tabCarre, 1);
    cout << "Appel de afficheColonne:" << endl;
    afficheColonne(tabCarre, 2);
    cout << "Appel de afficheDiagonale:" << endl;
    afficheDiagonale(tabCarre);
    cout << "Appel de affiche:" << endl;
    affiche(tabCarre);

    cout << "Lancement tests de appartient" << endl;
    appartientTest();
}

